#pragma once

#include <fstream>

typedef enum {
    SEED_INFILE,
    SEED_OUTFILE,
} SEED_FILE_TYPE;

class FileStream
{
public:
    FileStream(void);
    FileStream(const char* filename,
               SEED_FILE_TYPE fileType) { };

public:
    virtual ~FileStream(void) = 0;

public:
    virtual bool OpenFile() = 0;
    virtual void CloseFile() = 0;

    virtual void SeekStreamToStart() = 0;
    virtual void SeekStreamToEnd() = 0;

    virtual void SeekPast() = 0;
    virtual int GetSeekPosition() = 0;

    virtual bool Read() = 0;
    virtual bool Write() = 0;

    virtual int GetFileSize() = 0;

    virtual bool IsOpen() = 0;

protected:
    SEED_FILE_TYPE fileType;
};
