
#include "LogManager.h"
#include <stdio.h>
#include <stdarg.h>

//#include "mmgr.h"

#define DEFAULT_LOG	"log.txt"

FILE* m_hFile;

LogManager logger;


LogManager::LogManager()
 : filename(DEFAULT_LOG)
{
    this->Empty();
}

LogManager::~LogManager()
{
    Print("\nSEED Log - End");
}

bool
LogManager::Print( char *text, bool nl )
{
	if( !this->filename )
		this->filename = DEFAULT_LOG;

	if( fopen_s(&m_hFile, this->filename, "a+") != 0 )
		return false;

	fprintf(m_hFile, text);

	if( nl )
		putc('\n', m_hFile);

	// Close the file
	fclose(m_hFile);
	m_hFile = NULL;

	return true;
}

bool
LogManager::Printf( char* text, ... )
{
	va_list arg_list;

	if( !this->filename )
		this->filename = DEFAULT_LOG;

    const errno_t err = fopen_s(&m_hFile, this->filename, "a+");
	if( err != 0 )
		return false;

	va_start(arg_list, text);
    vfprintf_s(m_hFile, text, arg_list);
	va_end(arg_list);

	putc('\n', m_hFile);

	// Close the file
	fclose(m_hFile);
	m_hFile = NULL;

	return true;
}

bool
LogManager::Empty()
{
	if( !this->filename )
		this->filename = DEFAULT_LOG;

    if( !fopen_s(&m_hFile, this->filename, "w") )
		return false;

	fprintf(m_hFile, "SEED Log - Begin\n\n");

	fclose(m_hFile);
	m_hFile=NULL;

	return true;
}
