
#ifndef S_SEED_H
#define S_SEED_H


#include <vector>
using std::vector;

#include "seed_math.h"
#include "SeeDFont.h"

#define CLASSNAME	"OpenGL"
#define TITLE		"SEED Window"

//class seed_font;

// - engine - //

class SeeDEngine {
public:
	SeeDEngine()
	{ }

	//
	// Initialization and shutdown procedures
public:
	bool Initialize();
	bool Shutdown();

	// 
public:
	bool RunFrame();
	
	void Draw();
	void Draw( drawInfo_t &di, bool always = false ) {
		if( !always )
			vDrawModels.push_back(di);
		else
			vPersModels.push_back(di);
	}

	//
	// Loaders
public:
	int LoadModel(char*);
	int LoadTexture(char*);

	int LoadSound(char*);
	
	//
	// Drawing Functions
public:
	void DrawImage(float, float, float, float, float, float, float, float, textureIndex);
	void DrawModel();
	void Draw_Text( float x, float y, char *text, ... );
	
public:

	// Public Variables
public:

protected:
	SeeDFont            font;
	
	vector<drawInfo_t>  vDrawModels;	// models to draw next Draw()
	vector<drawInfo_t>  vPersModels;	// models to always draw
};

// does begin frame and end frame based on locality
class SeeDRenderObject {
public:
	SeeDRenderObject();
	~SeeDRenderObject();

	void go_2d();
	void go_3d();
};

#endif
