
#ifndef S_SEED_FRUSTUM_H
#define S_SEED_FRUSTUM_H

#include "seed_types.h"
#include <gmVec4.h>

typedef enum {
	F_OUT,
	F_INTERSECT,
	F_IN,
} FrustumResult;

class SeeDFrustum
{
public:
	SeeDFrustum();

	void  Calculate();

	FrustumResult  PointInFrustum(const gmVector3& point) const;
	FrustumResult  SphereInFrustum(const gmVector3& c, gmType r) const;
	FrustumResult  CubeInFrustum(const gmVector3& center, gmType size) const;
	FrustumResult  RectInFrustum(const gmVector3& center, const gmVector3& mins, const gmVector3& maxs) const;
	FrustumResult  RectInFrustum(const gmVector3* box) const;
//	FrustumResult  PlaneInFrustum(const gmVector4& plane) const;

	void Draw();

protected:
	enum sf_sides {
		SFS_RIGHT,
		SFS_LEFT,
		SFS_BOTTOM,
		SFS_TOP,
		SFS_BACK,		// far
		SFS_FRONT,		// near

		SFS_NUM_SIDES
	};

	gmVector4	frustumPlanes[SFS_NUM_SIDES]; // x, y, z, dist from origin
	gmVector4	frustumSphere;			// x, y, z, radius

	gmType	savedFOV;
	gmType	tanFOV;
};

extern SeeDFrustum frustum;

#endif
