
#ifndef S_SEED_KD_TREE_H
#define S_SEED_KD_TREE_H

#include "SeeDOrganizedSpace.h"

typedef enum {
	KDNP_X,
	KDNP_Y,
	KDNP_Z,
	KDNP_NUM_PLANES
} kd_node_plane;

typedef enum {
	KDN_FIRST,
	KDN_SECOND,
	KDN_NUM_NODES
} kd_node_dir;

class KDTreeNode : public SpatialNode<KDN_NUM_NODES>
{
public:
	KDTreeNode();

public:
	uint  Divide(TriangleList& tri_list) { return 0; }
	uint  GetPointDir(const gmVector3& point) const;
	uint  GetTriDir(const gmVector3& p1, const gmVector3& p2, const gmVector3& p3) const;

public:
	kd_node_plane splitPlane;
	gmType        splitScale;

	KDTreeNode*  nodes[KDN_NUM_NODES];
};


class SeeDKDTree : public SeeDOrganizedSpace<KDN_NUM_NODES, KDTreeNode>
{
protected:
	void  SplitNode(Node* node, TriangleList& triangleList);
	uint  DrawNode(Node* node, bool check_children=true) const;
};

#endif
