
#ifndef S_SeeDMedia_H
#define S_SeeDMedia_H

#include "SeeDModel.h"
#include "SeeDTexture.h"

#include <vector>
using std::vector;

class SeeDMedia
{
public:
	SeeDMedia();
	~SeeDMedia();

	bool Init();
	bool UnloadAll();

	void Draw(modelIndex mIndex);
	void Draw(drawInfo_t & di);

public:
	modelIndex   LoadModel(char *filename);
	textureIndex LoadTexture(char *filename);

public:
	// will ALWAYS return a texture object
	SeeDTexture *GetTexture(textureIndex index);

public:
	modelIndex   nullModelIndex;
	textureIndex nullTextureIndex;

protected:
	SeeDModel*   GetModelFromIndex(modelIndex index);
	SeeDTexture* GetTextureFromIndex(textureIndex index);

protected:
	ImageLoader         imageLoader;
	ModelLoader         modelLoader;

	vector<SeeDModel*>   modelList;
	vector<SeeDTexture*> textureList;
};

extern SeeDMedia media;

#endif
