#ifndef S_SEED_OCTREE_H
#define S_SEED_OCTREE_H

#include "SeeDOrganizedSpace.h"

typedef enum {
	TOP_LEFT_FRONT,
	TOP_LEFT_BACK,

	TOP_RIGHT_FRONT,
	TOP_RIGHT_BACK,

	BOTTOM_LEFT_FRONT,
	BOTTOM_LEFT_BACK,

	BOTTOM_RIGHT_FRONT,
	BOTTOM_RIGHT_BACK,

	NUM_NODES,

	NODE_INV
} node_dir;


class OctreeNode : public SpatialNode<NUM_NODES> {
public:
	OctreeNode()
	{ for(uint i=0;i<NUM_NODES;++i) nodes[i]=NULL; }

public:
	uint  GetPointDir(const gmVector3& point) const;

public:
	OctreeNode*  nodes[NUM_NODES];
};


class SeeDOctree : public SeeDOrganizedSpace<NUM_NODES, OctreeNode> {
	// Node Stuff
protected:
	void  SplitNode(Node* node, TriangleList& triangleList);
	uint  DrawNode(Node* node) const;
};

#endif
