
#ifndef S_SEED_QUADTREE_H
#define S_SEED_QUADTREE_H

#include "SeeDOrganizedSpace.h"

typedef enum {
	QN_TOP_LEFT,
	QN_TOP_RIGHT,
	QN_BOTTOM_LEFT,
	QN_BOTTOM_RIGHT,

	QN_NUM_NODES,

	QN_INVALID
} quadtree_node_dir;

class QuadtreeNode : public SpatialNode<QN_NUM_NODES>
{
public:
	QuadtreeNode()
	{ for(uint i=0;i<QN_NUM_NODES;++i) nodes[i]=NULL; }

public:
	byte GetPointDir(const gmVector3& point);
	byte GetTriDir(const gmVector3& p1, const gmVector3& p2, const gmVector3& p3);

public:
	QuadtreeNode* nodes[QN_NUM_NODES];
};

class SeeDQuadtree : public SeeDOrganizedSpace<QN_NUM_NODES, QuadtreeNode>
{
protected:
	void SplitNode(Node* node, TriangleList& triangleList);
	uint DrawNode(Node* node, bool checkChildren=true) const;
};

#endif
