
#include "SeeDVBOManager.h"
#include "SeeDOpenGL.h"

//seed_vbomanager	VBOManager;

void
SeeDVBOManager::_create(ulong size)
{
	glGenBuffersARB(1, &_buffer);
	glBindBufferARB(GL_ARRAY_BUFFER_ARB, _buffer);
}

void
SeeDVBOManager::_destroy()
{
}

void
SeeDVBOManager::Create(int n, uint* buffers)
{
	for( int i=0; i<n; ++i ) {
		BufferInfo info;

		info.index = assigned_buffers.size();
		info.size = 0;
		info.offset = -1;

		assigned_buffers.push_back(info);
	}
}

BufferInfo*
SeeDVBOManager::_get_info( uint index )
{
	uint n=assigned_buffers.size();

	for( uint i=0; i<n; ++i ) {
		if( assigned_buffers[i].index == index )
			return &assigned_buffers[i];
	}

	return NULL;
}

void
SeeDVBOManager::Bind(uint target, uint buffer)
{
	glBindBufferARB( target, _buffer );
	_current_target = target;
	_current_index  = buffer;
}

void
SeeDVBOManager::BufferData(uint target, int size, const void* data, uint usage)
{
	BufferInfo* info = _get_info( _current_index );

	glBindBufferARB(target, _buffer);
	glBufferSubDataARB( target, _used_size, size, data );

	info->offset = _used_size;
	info->size = size;
	_used_size += size;
}