
#ifndef S_SEED_VBOMANAGER_H
#define S_SEED_VBOMANAGER_H

#include "seed_types.h"

#include <vector>
using std::vector;

typedef struct BufferInfo_s {
	uint	index;
	uint	offset;
	uint	size;
} BufferInfo;

class SeeDVBOManager
{
public:
	void Create(int n, uint* buffers);
	void Bind(uint target, uint buffer);
	void BufferData(uint target, int size, const void* data, uint usage);
	void Unbind();

protected:
	void _create( ulong size );
	void _resize( ulong size );
	void _destroy();

	BufferInfo* _get_info( uint index );

protected:
	uint  _buffer;
	uint  _size;
	uint  _used_size;

	uint  _current_target;
	uint  _current_index;

	vector<BufferInfo> assigned_buffers;
};

//extern seed_vbomanager VBOManager;


#endif
