
#ifndef SEED_WINDOW_H_
#define SEED_WINDOW_H_

#include <windows.h>

typedef struct WindowInfo_s {
	LPCSTR       classname;
	LPCSTR       title;
	unsigned int x, y;
	unsigned int width, height;
	BYTE         bpp;
	unsigned int mode;
	bool         fullscreen;
} WindowInfo;

class SeeDWindow {
public:
	SeeDWindow()
	 : hWnd(NULL), hInstance(NULL)
	{ }

	virtual bool CreateWin(WindowInfo& windowInfo);
	virtual bool DestroyWin();

	virtual bool ChangeResolution(int width, int height, BYTE bpp);
//	virtual bool ToggleFullscreen();

public:
	HINSTANCE GetInstance() const { return hInstance; }
	HWND      GetWindow()   const { return hWnd;      }

	void GetInfo(WindowInfo& windowInfo);

protected:
	virtual bool Create();
	void         CheckMode();

protected:
	WindowInfo info;

	HWND       hWnd;
	HINSTANCE  hInstance;
};

#endif
