
#include "SeeDEngine.h"
#include "SeeDMedia.h"
#include "SeeDOpenGL.h"

//#include "mmgr.h"

typedef struct point_2d_s {
	TexCoord   uv;
	gmVector3  pos;
} point_2d_t;

void
SeeDEngine::DrawImage(float x, float y, float width, float height,
                      float s1, float t1, float s2, float t2, textureIndex img)
{
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

	glPushMatrix();
	glLoadIdentity();
	glTranslatef(x, y, 0);

	media.GetTexture(img)->Bind();

	glBegin(GL_QUADS);
		// left bottom
		glTexCoord2f(s1, 1.0f-t2);
		glVertex2f(x, y+height);

		// right bottom
		glTexCoord2f(s2, 1.0f-t2);
		glVertex2f(x+width, y+height);

		// right top
		glTexCoord2f(s2, 1.0f-t1);
		glVertex2f(x+width, y);

		// left top
		glTexCoord2f(s1, 1.0f-t1);
		glVertex2f(x, y);
	glEnd();

	glDisable(GL_TEXTURE_2D);
	glPopMatrix();
}
