

#include "SeeDMD3.h"
//#include "mdx_model.h"

#include <string.h>
#include <io.h>
#include <stdio.h>

//#include "mmgr.h"

SeeDModel::SeeDModel()
 : loaded(false), numSurfaces(0), surfaceList(NULL)
{
    this->name[0] = '\0';
}

SeeDModel::~SeeDModel()
{
}

bool
SeeDModel::Init()
{
	this->name[0] = '\0';
	this->numSurfaces = 0;
	this->surfaceList = NULL;
    this->loaded = false;
	return true;
}


//


ModelLoader::ModelLoader()
 : currentData(NULL)
{
    // empty
}

ModelLoader::~ModelLoader()
{
    // empty
}


#define MD3_IDENT       (('3'<<24)+('P'<<16)+('D'<<8)+'I')
#define MD3_VERSION     15
#define MAX_QPATH       64

typedef struct md_header_s {
	int			ident;
	int			version;
	char		name[MAX_QPATH];
} md_header_t;


SeeDModel*
ModelLoader::LoadModel(const char *filename)
{
	FILE* file = fopen(filename, "rb");
	if( file == NULL )
		return NULL;

	ulong filesize = filelength( fileno(file) );

	byte* _buffer = new byte[ filesize ];
	if( _buffer == NULL ) {
		fclose(file);
		return NULL;
	}

	fread(_buffer, sizeof(char), filesize, file);
	fclose(file);

	buffer = (char*)_buffer;

	md_header_t* header = (md_header_t*)buffer;

	switch( header->ident ) {
	case MD3_IDENT:
		this->currentData = new SeeDMD3;
		this->currentData->Load(buffer);
		break;

	default:
		JUST_DELETE_ARRAY(_buffer);
		break;
	};

	strcpy(this->currentData->name, filename);

	SAFE_DELETE_ARRAY(_buffer);

	return this->currentData;
}


