
#ifndef S_SEED_TYPES_H
#define S_SEED_TYPES_H

#include <gmVec3.h>

#ifndef NULL
#ifdef __cplusplus
#define NULL    0
#else
#define NULL    ((void *)0)
#endif
#endif

// shut up, you noisy compiler
#pragma warning( disable: 4786 )

typedef unsigned char	byte;
typedef unsigned short	word;
typedef unsigned int	uint;
typedef unsigned long	ulong;


/*typedef float   vec_t;
typedef vec_t   vec2_t[2];
typedef vec_t   vec3_t[3];
typedef vec_t   vec4_t[4];
*/

typedef gmType   matrix3x3[9];
typedef gmType   matrix4x4[16];
typedef gmType   matrix3x4[3][4];

typedef gmType   quaternion[4];

typedef uint    Triangle[3];

typedef uint    quad_t[4];
typedef quad_t  *quad_p;

typedef float   TexCoord[2];
//typedef float   rgb_t[3];

typedef float matrix_t[16];

#define SAFE_DELETE(o)       if((o)) { delete (o); (o)=NULL; }
#define SAFE_DELETE_ARRAY(o) if((o)) { delete [] (o); (o)=NULL; }
#define JUST_DELETE(o)       ((delete (o)), ((o)=NULL))
#define JUST_DELETE_ARRAY(o) ((delete [] (o)), ((o)=NULL))

typedef uint textureIndex;
typedef byte img_dat_t;

typedef unsigned int modelIndex;

typedef struct drawInfo_s {
    modelIndex   index;
    textureIndex texture;
    gmVector3    pos;
    gmVector3    axis[3];
    
    uint    frame;
    gmType  backLerp;
} drawInfo_t;


#define PTR_CAST(from, type)     ( (type*)(from) )
#define PTR_PCHAR(ptr)           ( PTR_CAST((ptr), char) )
#define PTR_OFF(from, off, type) ( PTR_CAST(PTR_PCHAR(from) + (off), type) )



#endif
