
#ifndef S_SEED_UTILS_H
#define S_SEED_UTILS_H

#include "seed_types.h"

#include <string>
using std::string;

//

typedef struct _iobuf FILE;

class WorkFile
{
public:
	//WorkFile(const char* filename, const char* mode);
	WorkFile(const string& filename, const string& mode);
	~WorkFile();

	FILE* Stream();
	void  Close();

private:
	FILE* stream;
};


class WorkBuffer
{
public:
	WorkBuffer();
	WorkBuffer(WorkFile& wf);
	//WorkBuffer(const char* filename, const char* mode);
    WorkBuffer(const string& filename, const string& mode);
	~WorkBuffer();

	bool Load(WorkFile& wf);

	bool Load(const string& filename, const string& mode);
	void Release();

	void* GetBuffer();
	long  GetBufferSize();

private:
	void* _buffer;
	long  _size;
};


const string GetExtension(const string& filename);
const string StripExtension(const string& filename);
const string DefaultExtension(const string& filename, const string& ext);

#endif
