

#include "seed_math.h"
#include "seed_vdpm.h"



bool outside_view_frustum( Vertex * vs ) {
	return false;
}

bool oriented_away( Vertex * vs ) {
	return false;
}

bool is_invisible( Vertex * vs ) {
	return outside_view_frustum(vs);
}

short gtime=0;


void SRMesh::vsplit( Vertex * vs ) {
	Vertex	*vt = &vertices[ vs->i * 2 ];
	Vertex	*vu = vt + 1;
	Face	*fl = &faces[ vs->i * 2 ];
	Face	*fr = fl + 1;

	Face	*f0 = vsplits[vs->i].fn[0];
	Face	*f1 = vsplits[vs->i].fn[1];
	Face	*f2 = vsplits[vs->i].fn[2];
	Face	*f3 = vsplits[vs->i].fn[3];

	vt->avertex = vs->avertex;
	vt->avertex->vertex = vt;
	vs->avertex->vertex = NULL;

	vu->avertex = new AVertex;
	vu->avertex->vertex = vu;
	active_vertices.append( &vu->avertex->listnode );
	vu->avertex->vgeom = vsplits[vs->i].vu_vgeom;

	fl->aface = new AFace;
	active_faces.append( &fl->aface->listnode );
	// fill in fl

	fr->aface = new AFace;
	active_faces.append( &fr->aface->listnode );
	// fill in fr

	// update neighbors to point to fl, fr

	// for each face f around vu: update f->vertices[..]: vs -> vu

	if( !is_invisible(vs) ) {
		vu->avertex->vgeom = vt->avertex->vgeom;
		VertexMorph *vm = vu->avertex->vmorph = new VertexMorph;
		vm->coarsening = false;
		vm->gtime = gtime;
		vm->vg_refined = vsplits[vs->i].vu_vgeom;

		VectorSubtract(vm->vg_refined.point, vu->avertex->vgeom.point, vm->vginc.point);
		VectorScale(vm->vginc.point, 1/gtime, vm->vginc.point);
	}
}


void SRMesh::update_vmorphs() {
	ListNode	*n;
	for( n=active_vertices.next; n; n=n->next ) {
		AVertex *v = (AVertex*)n;
		if( v->vmorph ) {
			VectorAdd(v->vgeom.point, v->vmorph->vginc.point, v->vgeom.point);
			v->vmorph->gtime--;
			if( v->vmorph->gtime == 0 ) {
				delete v->vmorph;
				v->vmorph = NULL;
			}
		}
	}
}

void force_vsplit( Vertex *vs ) {
}

void SRMesh::adapt_refinement() {
	ListNode	*n;
	for( n=active_vertices.next; n; n=n->next ) {
		AVertex *v = (AVertex*)n;
		Vertex	*vs = v->vertex;
		
		if( vs->i >= 0 && !is_invisible(vs) && screen_error(vs) > tau )
			force_vsplit( vs );
		else if( vs->parent && ecol_legal(vs->parent) ) {
			bool vmc = ( v->vmorph && v->vmorph->coarsening );
			if( is_invisible(vs->parent) ) {
				if( vmc )	finish_geomorph_coarsening( v );
				ecol( vs->parent );
			} else if( screen_error(vs->parent) > tau ) {
				if( vmc )	abort_geomorph_coarsening( v );
			} else if( vmc ) {
				if( v->vmorph->gtime == 1 ) {
					finish_geomorph_coarsening( v );
					ecol( vs->parent );
				}
			} else {
				start_geomorph_coarsening( vs );
			}
		}
	}
}